/*
 * BW.C
 * Computer Buzzword Generator
 * By Joshua Levy
 * From specification by .
 */

#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <ctype.h>

#include "random.h"
#include "table.h"

main(argc,argv) int argc ; char *argv[] ;
{
    table_t *first, *second, *third ;
    char *result1, *result2, *result3 ;
    long seed=0 ;
    int count=1 ;
    int i ;
    int sts ;

    /* parse the command line arguments */
    if (argc<=1) {
	printf("usage: bw <seed> <number>\n") ;
	printf("This will cause generation of <number> of buzzwords.\n") ;
	printf("Using <seed> and a random number seed.\n") ;
	printf("Seed defaults to 0, count to 1.  Buzzword example:\n\n");
    }
    if (argc>=2) 
	seed = atol(argv[1]) ;
    if (argc>=3) 
	count = atoi(argv[2]) ;

    /*
     * Initialize the random number generater and the three tables.
     */
    ra_seed(seed) ;
    sts = tb_read("bw1.tab",&first) ;    assert(sts==TB_OK) ;
    sts = tb_read("bw2.tab",&second) ;   assert(sts==TB_OK) ;
    sts = tb_read("bw3.tab",&third) ;   assert(sts==TB_OK) ;

    /*
     * Print out the three tables (mostly for debugging).
    sts = tb_tbl(first,"",0) ;     assert(sts==TB_OK) ;
    sts = tb_tbl(second,"",0) ;    assert(sts==TB_OK) ;
    sts = tb_tbl(third,"",0) ;    assert(sts==TB_OK) ;
     */

    for(i=0 ; i<count ; i++) {
	sts = tb_use(first,&result1) ;	assert(sts==TB_OK) ;
	sts = tb_use(second,&result2) ;	assert(sts==TB_OK) ;
	sts = tb_use(third,&result3) ;	assert(sts==TB_OK) ;
	printf("%s %s %s\n",result1,result2,result3) ;
    }

    /* these three frees are not really needed, since the program will end */
    sts = tb_free(first) ;    assert(sts==TB_OK) ;
    sts = tb_free(second) ;   assert(sts==TB_OK) ;
    sts = tb_free(third) ;    assert(sts==TB_OK) ;
}


