/*
 * CNAME.C
 * A Cyberpunk style name generator.
 * By Joshua levy  
 *
%  cc -g -I.. -o cname cname.c ../table.a ../random.o
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <assert.h>

#include "random.h"
#include "table.h"

extern char *optarg ;

main(argc,argv) int argc ; char *argv[] ;
{
    table_t *table1 ;
    char *result1 ;
    char *result2 ;
    int count=1, i ;
    int sts=0 ;
    int seed=0 ;
    int ch ;

    if (argc<=1) {
	printf("usage: cname -r <rand> -c <count>\nAn example result is:\n") ;
    }
    while ((ch=getopt(argc,argv,"c:r:")) != -1) {
	switch (ch) {
	  case 'c': count = atoi(optarg) ; break ;
	  case 'r': seed = atoi(optarg) ;  break ;
	}
    }
    ra_seed(seed) ;
    tb_read("cname.tab",&table1) ;
    assert(sts==TB_OK) ;

    for(i=0 ; i<count ; i++) {
	sts = tb_use(table1,"1",&result1) ;
	assert(sts==TB_OK) ;
	sts = tb_use(table1,"2",&result2) ;
	assert(sts==TB_OK) ;
	printf("%s%s\n",result1,result2) ;
    }

    sts = tb_free(table1) ;
    assert(sts==TB_OK) ;
}


